#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

#include <QSerialPort>
#include <QSerialPortInfo>
#include <QLineEdit>
#include <QGridLayout>

#include "JsonTreeModel.h"

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

private:
    Ui::MainWindow *ui;

    /* 串口对象 */
    QSerialPort *serialPort;

    QLineEdit *fileLineEdit;

    JsonTreeModel *jsonModel;

    QString loadpath;

    bool openSerialPortFlag;
    bool openFileFlag;

    void Init();
    void scanSerialPort();
    void parityItemInit();

    uint8_t *analysisReadCfgData(uint8_t **cfgData);

    uint16_t modbusCrc(uint8_t *arr_buff, uint8_t len);

private slots:
    void openFile();
    void openSerialPortPushButtonClicked();
    void readCfgFile();
    void writeCfgFile();
};
#endif // MAINWINDOW_H
